/* DisplaysView.c generated by valac 0.56.17, the Vala compiler
 * generated from DisplaysView.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-2.0-or-later
 * SPDX-FileCopyrightText: 2014-2023 elementary, Inc. (https://elementary.io)
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 *              Oleksandr Lynok <oleksandr.lynok@gmail.com>
 */

#include "display.h"
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <granite-7.h>
#include <gee.h>
#include <float.h>
#include <math.h>

#define DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH "org.gnome.settings-daemon.peripherals.touchscreen"
#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	DISPLAY_DISPLAYS_VIEW_0_PROPERTY,
	DISPLAY_DISPLAYS_VIEW_NUM_PROPERTIES
};
static GParamSpec* display_displays_view_properties[DISPLAY_DISPLAYS_VIEW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY (display_displays_view_sensor_proxy_get_type ())
#define DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, DisplayDisplaysViewSensorProxy))
#define DISPLAY_DISPLAYS_VIEW_IS_SENSOR_PROXY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY))
#define DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, DisplayDisplaysViewSensorProxyIface))

typedef struct _DisplayDisplaysViewSensorProxy DisplayDisplaysViewSensorProxy;
typedef struct _DisplayDisplaysViewSensorProxyIface DisplayDisplaysViewSensorProxyIface;

#define DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY_PROXY (display_displays_view_sensor_proxy_proxy_get_type ())
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _DisplayDisplaysViewDetectAccelerometerData DisplayDisplaysViewDetectAccelerometerData;
typedef GDBusProxy DisplayDisplaysViewSensorProxyProxy;
typedef GDBusProxyClass DisplayDisplaysViewSensorProxyProxyClass;
typedef struct _Block3Data Block3Data;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_settings_schema_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_unref (var), NULL)))
#define _g_settings_schema_source_unref0(var) ((var == NULL) ? NULL : (var = (g_settings_schema_source_unref (var), NULL)))

struct _DisplayDisplaysViewPrivate {
	GtkComboBoxText* dpi_combo;
	GtkBox* rotation_lock_box;
};

struct _DisplayDisplaysViewSensorProxyIface {
	GTypeInterface parent_iface;
	gboolean (*get_has_accelerometer) (DisplayDisplaysViewSensorProxy* self);
};

struct _DisplayDisplaysViewDetectAccelerometerData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	DisplayDisplaysView* self;
	gboolean has_accelerometer;
	DisplayDisplaysViewSensorProxy* sensors;
	DisplayDisplaysViewSensorProxy* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GError* e;
	GError* _tmp3_;
	const gchar* _tmp4_;
	GSettings* touchscreen_settings;
	GSettings* _tmp5_;
	GtkLabel* rotation_lock_label;
	GtkLabel* _tmp6_;
	GtkSwitch* rotation_lock_switch;
	GtkSwitch* _tmp7_;
	GtkBox* _tmp8_;
	GtkLabel* _tmp9_;
	GtkBox* _tmp10_;
	GtkSwitch* _tmp11_;
	GSettings* _tmp12_;
	GtkSwitch* _tmp13_;
	GError* _inner_error0_;
};

struct _Block3Data {
	int _ref_count_;
	DisplayDisplaysView* self;
	GtkSwitch* mirror_switch;
	GtkBox* mirror_box;
	GtkButton* apply_button;
	DisplayMonitorManager* monitor_manager;
};

static gint DisplayDisplaysView_private_offset;
static gpointer display_displays_view_parent_class = NULL;

static void display_displays_view_detect_accelerometer_data_free (gpointer _data);
static void display_displays_view_detect_accelerometer (DisplayDisplaysView* self,
                                                 GAsyncReadyCallback _callback_,
                                                 gpointer _user_data_);
static void display_displays_view_detect_accelerometer_finish (DisplayDisplaysView* self,
                                                        GAsyncResult* _res_);
static gboolean display_displays_view_detect_accelerometer_co (DisplayDisplaysViewDetectAccelerometerData* _data_);
static GType display_displays_view_sensor_proxy_get_type (void) G_GNUC_CONST  G_GNUC_UNUSED ;
VALA_EXTERN GType display_displays_view_sensor_proxy_proxy_get_type (void) G_GNUC_CONST ;
static guint display_displays_view_sensor_proxy_register_object (void* object,
                                                          GDBusConnection* connection,
                                                          const gchar* path,
                                                          GError** error);
static void display_displays_view_detect_accelerometer_ready (GObject* source_object,
                                                       GAsyncResult* _res_,
                                                       gpointer _user_data_);
VALA_EXTERN gboolean display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static GType display_displays_view_sensor_proxy_get_type_once (void);
static void display_displays_view_sensor_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                        const gchar* sender_name,
                                                        const gchar* signal_name,
                                                        GVariant* parameters);
static gboolean display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static void display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init (DisplayDisplaysViewSensorProxyIface* iface);
static void display_displays_view_sensor_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                                    const gchar* sender,
                                                                    const gchar* object_path,
                                                                    const gchar* interface_name,
                                                                    const gchar* method_name,
                                                                    GVariant* parameters,
                                                                    GDBusMethodInvocation* invocation,
                                                                    gpointer user_data);
static GVariant* display_displays_view_sensor_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                          const gchar* sender,
                                                                          const gchar* object_path,
                                                                          const gchar* interface_name,
                                                                          const gchar* property_name,
                                                                          GError** error,
                                                                          gpointer user_data);
static GVariant* _dbus_display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self);
static gboolean display_displays_view_sensor_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                         const gchar* sender,
                                                                         const gchar* object_path,
                                                                         const gchar* interface_name,
                                                                         const gchar* property_name,
                                                                         GVariant* value,
                                                                         GError** error,
                                                                         gpointer user_data);
static void _display_displays_view_sensor_proxy_unregister_object (gpointer user_data);
static GObject * display_displays_view_constructor (GType type,
                                             guint n_construct_properties,
                                             GObjectConstructParam * construct_properties);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void _display_displays_view___lambda17_ (Block3Data* _data3_,
                                         gboolean changed);
static void __display_displays_view___lambda17__display_displays_overlay_configuration_changed (DisplayDisplaysOverlay* _sender,
                                                                                         gboolean changed,
                                                                                         gpointer self);
static void _display_displays_view___lambda18_ (Block3Data* _data3_);
static void __display_displays_view___lambda18__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void _display_displays_view___lambda19_ (DisplayDisplaysView* self);
static void __display_displays_view___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _display_displays_view___lambda20_ (Block3Data* _data3_);
static void __display_displays_view___lambda20__gtk_button_clicked (GtkButton* _sender,
                                                             gpointer self);
static void _display_displays_view___lambda21_ (Block3Data* _data3_);
static void __display_displays_view___lambda21__gtk_combo_box_changed (GtkComboBox* _sender,
                                                                gpointer self);
static void _display_displays_view___lambda22_ (Block3Data* _data3_);
static void __display_displays_view___lambda22__g_object_notify (GObject* _sender,
                                                          GParamSpec* pspec,
                                                          gpointer self);
static void display_displays_view_finalize (GObject * obj);
static GType display_displays_view_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static const GDBusMethodInfo * const _display_displays_view_sensor_proxy_dbus_method_info[] = {NULL};
static const GDBusSignalInfo * const _display_displays_view_sensor_proxy_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo _display_displays_view_sensor_proxy_dbus_property_info_has_accelerometer = {-1, "HasAccelerometer", "b", G_DBUS_PROPERTY_INFO_FLAGS_READABLE, NULL};
static const GDBusPropertyInfo * const _display_displays_view_sensor_proxy_dbus_property_info[] = {&_display_displays_view_sensor_proxy_dbus_property_info_has_accelerometer, NULL};
static const GDBusInterfaceInfo _display_displays_view_sensor_proxy_dbus_interface_info = {-1, "net.hadess.SensorProxy", (GDBusMethodInfo **) (&_display_displays_view_sensor_proxy_dbus_method_info), (GDBusSignalInfo **) (&_display_displays_view_sensor_proxy_dbus_signal_info), (GDBusPropertyInfo **) (&_display_displays_view_sensor_proxy_dbus_property_info), NULL};
static const GDBusInterfaceVTable _display_displays_view_sensor_proxy_dbus_interface_vtable = {display_displays_view_sensor_proxy_dbus_interface_method_call, display_displays_view_sensor_proxy_dbus_interface_get_property, display_displays_view_sensor_proxy_dbus_interface_set_property};

static inline gpointer
display_displays_view_get_instance_private (DisplayDisplaysView* self)
{
	return G_STRUCT_MEMBER_P (self, DisplayDisplaysView_private_offset);
}

static void
display_displays_view_detect_accelerometer_data_free (gpointer _data)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	_data_ = _data;
	_g_object_unref0 (_data_->self);
	g_slice_free (DisplayDisplaysViewDetectAccelerometerData, _data_);
}

static gpointer
_g_object_ref0 (gpointer self)
{
	return self ? g_object_ref (self) : NULL;
}

static void
display_displays_view_detect_accelerometer (DisplayDisplaysView* self,
                                            GAsyncReadyCallback _callback_,
                                            gpointer _user_data_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	DisplayDisplaysView* _tmp0_;
	g_return_if_fail (self != NULL);
	_data_ = g_slice_new0 (DisplayDisplaysViewDetectAccelerometerData);
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
	g_task_set_task_data (_data_->_async_result, _data_, display_displays_view_detect_accelerometer_data_free);
	_tmp0_ = _g_object_ref0 (self);
	_data_->self = _tmp0_;
	display_displays_view_detect_accelerometer_co (_data_);
}

static void
display_displays_view_detect_accelerometer_finish (DisplayDisplaysView* self,
                                                   GAsyncResult* _res_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
}

static void
display_displays_view_detect_accelerometer_ready (GObject* source_object,
                                                  GAsyncResult* _res_,
                                                  gpointer _user_data_)
{
	DisplayDisplaysViewDetectAccelerometerData* _data_;
	_data_ = _user_data_;
	_data_->_source_object_ = source_object;
	_data_->_res_ = _res_;
	display_displays_view_detect_accelerometer_co (_data_);
}

static gboolean
display_displays_view_detect_accelerometer_co (DisplayDisplaysViewDetectAccelerometerData* _data_)
{
	switch (_data_->_state_) {
		case 0:
		goto _state_0;
		case 1:
		goto _state_1;
		default:
		g_assert_not_reached ();
	}
	_state_0:
	_data_->has_accelerometer = FALSE;
	{
		_data_->_state_ = 1;
		g_async_initable_new_async (DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY_PROXY, 0, NULL, display_displays_view_detect_accelerometer_ready, _data_, "g-flags", 0, "g-name", "net.hadess.SensorProxy", "g-bus-type", G_BUS_TYPE_SYSTEM, "g-object-path", "/net/hadess/SensorProxy", "g-interface-name", "net.hadess.SensorProxy", NULL);
		return FALSE;
		_state_1:
		_data_->_tmp0_ = (DisplayDisplaysViewSensorProxy*) g_async_initable_new_finish ((GAsyncInitable *) _data_->_source_object_, _data_->_res_, &_data_->_inner_error0_);
		_data_->sensors = (DisplayDisplaysViewSensorProxy*) _data_->_tmp0_;
		if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
			goto __catch0_g_error;
		}
		_data_->_tmp1_ = display_displays_view_sensor_proxy_get_has_accelerometer (_data_->sensors);
		_data_->_tmp2_ = _data_->_tmp1_;
		_data_->has_accelerometer = _data_->_tmp2_;
		_g_object_unref0 (_data_->sensors);
	}
	goto __finally0;
	__catch0_g_error:
	{
		_data_->e = _data_->_inner_error0_;
		_data_->_inner_error0_ = NULL;
		_data_->_tmp3_ = _data_->e;
		_data_->_tmp4_ = _data_->_tmp3_->message;
		g_info ("DisplaysView.vala:139: Unable to connect to SensorProxy bus, probably " \
"means no accelerometer supported: %s", _data_->_tmp4_);
		_g_error_free0 (_data_->e);
	}
	__finally0:
	if (G_UNLIKELY (_data_->_inner_error0_ != NULL)) {
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error0_->message, g_quark_to_string (_data_->_inner_error0_->domain), _data_->_inner_error0_->code);
		g_clear_error (&_data_->_inner_error0_);
		g_object_unref (_data_->_async_result);
		return FALSE;
	}
	if (_data_->has_accelerometer) {
		_data_->_tmp5_ = g_settings_new (DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH);
		_data_->touchscreen_settings = _data_->_tmp5_;
		_data_->_tmp6_ = (GtkLabel*) gtk_label_new (_ ("Rotation Lock:"));
		g_object_ref_sink (_data_->_tmp6_);
		_data_->rotation_lock_label = _data_->_tmp6_;
		_data_->_tmp7_ = (GtkSwitch*) gtk_switch_new ();
		g_object_ref_sink (_data_->_tmp7_);
		_data_->rotation_lock_switch = _data_->_tmp7_;
		_data_->_tmp8_ = _data_->self->priv->rotation_lock_box;
		_data_->_tmp9_ = _data_->rotation_lock_label;
		gtk_box_append (_data_->_tmp8_, (GtkWidget*) _data_->_tmp9_);
		_data_->_tmp10_ = _data_->self->priv->rotation_lock_box;
		_data_->_tmp11_ = _data_->rotation_lock_switch;
		gtk_box_append (_data_->_tmp10_, (GtkWidget*) _data_->_tmp11_);
		_data_->_tmp12_ = _data_->touchscreen_settings;
		_data_->_tmp13_ = _data_->rotation_lock_switch;
		g_settings_bind (_data_->_tmp12_, "orientation-lock", (GObject*) _data_->_tmp13_, "state", G_SETTINGS_BIND_DEFAULT);
		_g_object_unref0 (_data_->rotation_lock_switch);
		_g_object_unref0 (_data_->rotation_lock_label);
		_g_object_unref0 (_data_->touchscreen_settings);
	}
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
	if (_data_->_state_ != 0) {
		while (!g_task_get_completed (_data_->_async_result)) {
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
		}
	}
	g_object_unref (_data_->_async_result);
	return FALSE;
}

DisplayDisplaysView*
display_displays_view_construct (GType object_type)
{
	DisplayDisplaysView * self = NULL;
	self = (DisplayDisplaysView*) g_object_new (object_type, NULL);
	return self;
}

DisplayDisplaysView*
display_displays_view_new (void)
{
	return display_displays_view_construct (DISPLAY_TYPE_DISPLAYS_VIEW);
}

gboolean
display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	DisplayDisplaysViewSensorProxyIface* _iface_;
	g_return_val_if_fail (self != NULL, FALSE);
	_iface_ = DISPLAY_DISPLAYS_VIEW_SENSOR_PROXY_GET_INTERFACE (self);
	if (_iface_->get_has_accelerometer) {
		return _iface_->get_has_accelerometer (self);
	}
	return FALSE;
}

static void
display_displays_view_sensor_proxy_default_init (DisplayDisplaysViewSensorProxyIface * iface,
                                                 gpointer iface_data)
{
}

static GType
display_displays_view_sensor_proxy_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplaysViewSensorProxyIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_displays_view_sensor_proxy_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType display_displays_view_sensor_proxy_type_id;
	display_displays_view_sensor_proxy_type_id = g_type_register_static (G_TYPE_INTERFACE, "DisplayDisplaysViewSensorProxy", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (display_displays_view_sensor_proxy_type_id, g_dbus_proxy_get_type ());
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) display_displays_view_sensor_proxy_proxy_get_type);
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "net.hadess.SensorProxy");
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_display_displays_view_sensor_proxy_dbus_interface_info));
	g_type_set_qdata (display_displays_view_sensor_proxy_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) display_displays_view_sensor_proxy_register_object);
	return display_displays_view_sensor_proxy_type_id;
}

static GType
display_displays_view_sensor_proxy_get_type (void)
{
	static volatile gsize display_displays_view_sensor_proxy_type_id__once = 0;
	if (g_once_init_enter (&display_displays_view_sensor_proxy_type_id__once)) {
		GType display_displays_view_sensor_proxy_type_id;
		display_displays_view_sensor_proxy_type_id = display_displays_view_sensor_proxy_get_type_once ();
		g_once_init_leave (&display_displays_view_sensor_proxy_type_id__once, display_displays_view_sensor_proxy_type_id);
	}
	return display_displays_view_sensor_proxy_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (DisplayDisplaysViewSensorProxyProxy, display_displays_view_sensor_proxy_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (DISPLAY_DISPLAYS_VIEW_TYPE_SENSOR_PROXY, display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init) )
static void
display_displays_view_sensor_proxy_proxy_class_init (DisplayDisplaysViewSensorProxyProxyClass* klass)
{
	G_DBUS_PROXY_CLASS (klass)->g_signal = display_displays_view_sensor_proxy_proxy_g_signal;
}

static void
display_displays_view_sensor_proxy_proxy_g_signal (GDBusProxy* proxy,
                                                   const gchar* sender_name,
                                                   const gchar* signal_name,
                                                   GVariant* parameters)
{
}

static void
display_displays_view_sensor_proxy_proxy_init (DisplayDisplaysViewSensorProxyProxy* self)
{
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_display_displays_view_sensor_proxy_dbus_interface_info));
}

static gboolean
display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	GVariant *_inner_reply;
	gboolean _result;
	_inner_reply = g_dbus_proxy_get_cached_property ((GDBusProxy *) self, "HasAccelerometer");
	if (!_inner_reply) {
		GVariant *_arguments;
		GVariant *_reply;
		GVariantBuilder _arguments_builder;
		g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("net.hadess.SensorProxy"));
		g_variant_builder_add_value (&_arguments_builder, g_variant_new_string ("HasAccelerometer"));
		_arguments = g_variant_builder_end (&_arguments_builder);
		_reply = g_dbus_proxy_call_sync ((GDBusProxy *) self, "org.freedesktop.DBus.Properties.Get", _arguments, G_DBUS_CALL_FLAGS_NONE, -1, NULL, NULL);
		if (!_reply) {
			gboolean _tmp0_ = FALSE;
			return _tmp0_;
		}
		g_variant_get (_reply, "(v)", &_inner_reply);
		g_variant_unref (_reply);
	}
	_result = g_variant_get_boolean (_inner_reply);
	g_variant_unref (_inner_reply);
	return _result;
}

static void
display_displays_view_sensor_proxy_proxy_display_displays_view_sensor_proxy_interface_init (DisplayDisplaysViewSensorProxyIface* iface)
{
	iface->get_has_accelerometer = display_displays_view_sensor_proxy_dbus_proxy_get_has_accelerometer;
}

static void
display_displays_view_sensor_proxy_dbus_interface_method_call (GDBusConnection* connection,
                                                               const gchar* sender,
                                                               const gchar* object_path,
                                                               const gchar* interface_name,
                                                               const gchar* method_name,
                                                               GVariant* parameters,
                                                               GDBusMethodInvocation* invocation,
                                                               gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	g_object_unref (invocation);
}

static GVariant*
_dbus_display_displays_view_sensor_proxy_get_has_accelerometer (DisplayDisplaysViewSensorProxy* self)
{
	gboolean result;
	GVariant* _reply;
	result = display_displays_view_sensor_proxy_get_has_accelerometer (self);
	_reply = g_variant_new_boolean (result);
	return _reply;
}

static GVariant*
display_displays_view_sensor_proxy_dbus_interface_get_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GError** error,
                                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	if (strcmp (property_name, "HasAccelerometer") == 0) {
		return _dbus_display_displays_view_sensor_proxy_get_has_accelerometer (object);
	}
	return NULL;
}

static gboolean
display_displays_view_sensor_proxy_dbus_interface_set_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GVariant* value,
                                                                GError** error,
                                                                gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
	return FALSE;
}

static guint
display_displays_view_sensor_proxy_register_object (gpointer object,
                                                    GDBusConnection* connection,
                                                    const gchar* path,
                                                    GError** error)
{
	guint result;
	gpointer *data;
	data = g_new (gpointer, 3);
	data[0] = g_object_ref (object);
	data[1] = g_object_ref (connection);
	data[2] = g_strdup (path);
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_display_displays_view_sensor_proxy_dbus_interface_info), &_display_displays_view_sensor_proxy_dbus_interface_vtable, data, _display_displays_view_sensor_proxy_unregister_object, error);
	if (!result) {
		return 0;
	}
	return result;
}

static void
_display_displays_view_sensor_proxy_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
	g_object_unref (data[0]);
	g_object_unref (data[1]);
	g_free (data[2]);
	g_free (data);
}

static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
	g_atomic_int_inc (&_data3_->_ref_count_);
	return _data3_;
}

static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
		DisplayDisplaysView* self;
		self = _data3_->self;
		_g_object_unref0 (_data3_->apply_button);
		_g_object_unref0 (_data3_->mirror_box);
		_g_object_unref0 (_data3_->mirror_switch);
		_g_object_unref0 (self);
		g_slice_free (Block3Data, _data3_);
	}
}

static gpointer
_g_settings_schema_source_ref0 (gpointer self)
{
	return self ? g_settings_schema_source_ref (self) : NULL;
}

static void
_display_displays_view___lambda17_ (Block3Data* _data3_,
                                    gboolean changed)
{
	DisplayDisplaysView* self;
	GtkButton* _tmp0_;
	self = _data3_->self;
	_tmp0_ = _data3_->apply_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, changed);
}

static void
__display_displays_view___lambda17__display_displays_overlay_configuration_changed (DisplayDisplaysOverlay* _sender,
                                                                                    gboolean changed,
                                                                                    gpointer self)
{
	_display_displays_view___lambda17_ (self, changed);
}

static void
_display_displays_view___lambda18_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	GtkBox* _tmp0_;
	DisplayMonitorManager* _tmp1_;
	GeeLinkedList* _tmp2_;
	GeeLinkedList* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	self = _data3_->self;
	_tmp0_ = _data3_->mirror_box;
	_tmp1_ = _data3_->monitor_manager;
	_tmp2_ = display_monitor_manager_get_monitors (_tmp1_);
	_tmp3_ = _tmp2_;
	_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
	_tmp5_ = _tmp4_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, _tmp5_ > 1);
}

static void
__display_displays_view___lambda18__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_display_displays_view___lambda18_ (self);
}

static void
_display_displays_view___lambda19_ (DisplayDisplaysView* self)
{
	DisplayDisplaysOverlay* _tmp0_;
	_tmp0_ = self->displays_overlay;
	display_displays_overlay_rescan_displays (_tmp0_);
}

static void
__display_displays_view___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
	_display_displays_view___lambda19_ ((DisplayDisplaysView*) self);
}

static void
_display_displays_view___lambda20_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	DisplayMonitorManager* _tmp0_;
	GtkButton* _tmp1_;
	self = _data3_->self;
	_tmp0_ = _data3_->monitor_manager;
	display_monitor_manager_set_monitor_config (_tmp0_);
	_tmp1_ = _data3_->apply_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
}

static void
__display_displays_view___lambda20__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self)
{
	_display_displays_view___lambda20_ (self);
}

static void
_display_displays_view___lambda21_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	DisplayMonitorManager* _tmp0_;
	GtkComboBoxText* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	self = _data3_->self;
	_tmp0_ = _data3_->monitor_manager;
	_tmp1_ = self->priv->dpi_combo;
	_tmp2_ = gtk_combo_box_get_active ((GtkComboBox*) _tmp1_);
	_tmp3_ = _tmp2_;
	display_monitor_manager_set_scale_on_all_monitors (_tmp0_, (gdouble) (_tmp3_ + 1));
}

static void
__display_displays_view___lambda21__gtk_combo_box_changed (GtkComboBox* _sender,
                                                           gpointer self)
{
	_display_displays_view___lambda21_ (self);
}

static void
_display_displays_view___lambda22_ (Block3Data* _data3_)
{
	DisplayDisplaysView* self;
	GtkSwitch* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
	GtkButton* _tmp5_;
	self = _data3_->self;
	_tmp0_ = _data3_->mirror_switch;
	_tmp1_ = gtk_switch_get_active (_tmp0_);
	_tmp2_ = _tmp1_;
	if (_tmp2_) {
		DisplayMonitorManager* _tmp3_;
		_tmp3_ = _data3_->monitor_manager;
		display_monitor_manager_enable_clone_mode (_tmp3_);
	} else {
		DisplayMonitorManager* _tmp4_;
		_tmp4_ = _data3_->monitor_manager;
		display_monitor_manager_disable_clone_mode (_tmp4_);
	}
	_tmp5_ = _data3_->apply_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp5_, TRUE);
}

static void
__display_displays_view___lambda22__g_object_notify (GObject* _sender,
                                                     GParamSpec* pspec,
                                                     gpointer self)
{
	_display_displays_view___lambda22_ (self);
}

static GObject *
display_displays_view_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DisplayDisplaysView * self;
	Block3Data* _data3_;
	DisplayDisplaysOverlay* _tmp0_ = NULL;
	GtkLabel* mirror_label = NULL;
	GtkLabel* _tmp1_;
	GtkSwitch* _tmp2_;
	GtkBox* _tmp3_ = NULL;
	GtkBox* _tmp4_;
	GtkLabel* _tmp5_;
	GtkBox* _tmp6_;
	GtkSwitch* _tmp7_;
	GtkLabel* dpi_label = NULL;
	GtkLabel* _tmp8_;
	GtkComboBoxText* _tmp9_;
	GtkComboBoxText* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	GtkComboBoxText* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GtkComboBoxText* _tmp16_;
	gchar* _tmp17_;
	gchar* _tmp18_;
	GtkBox* dpi_box = NULL;
	GtkBox* _tmp19_ = NULL;
	GtkBox* _tmp20_;
	GtkLabel* _tmp21_;
	GtkBox* _tmp22_;
	GtkComboBoxText* _tmp23_;
	GtkButton* detect_button = NULL;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkBox* button_box = NULL;
	GtkBox* _tmp28_ = NULL;
	GtkBox* _tmp29_;
	GtkButton* _tmp30_;
	GtkBox* _tmp31_;
	GtkButton* _tmp32_;
	GtkActionBar* action_bar = NULL;
	GtkActionBar* _tmp33_;
	GtkActionBar* _tmp34_;
	GtkActionBar* _tmp35_;
	GtkBox* _tmp36_;
	GtkActionBar* _tmp37_;
	GtkBox* _tmp38_;
	GSettingsSchemaSource* schema_source = NULL;
	GSettingsSchemaSource* _tmp39_;
	GSettingsSchemaSource* _tmp40_;
	GSettingsSchema* rotation_lock_schema = NULL;
	GSettingsSchemaSource* _tmp41_;
	GSettingsSchema* _tmp42_;
	GSettingsSchema* _tmp43_;
	GtkActionBar* _tmp47_;
	GtkBox* _tmp48_;
	GtkSeparator* _tmp49_;
	GtkSeparator* _tmp50_;
	DisplayDisplaysOverlay* _tmp51_;
	GtkActionBar* _tmp52_;
	DisplayDisplaysOverlay* _tmp53_;
	DisplayMonitorManager* _tmp54_;
	GtkBox* _tmp55_;
	DisplayMonitorManager* _tmp56_;
	GeeLinkedList* _tmp57_;
	GeeLinkedList* _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	DisplayMonitorManager* _tmp61_;
	GtkButton* _tmp62_;
	GtkButton* _tmp63_;
	GtkComboBoxText* _tmp64_;
	DisplayMonitorManager* _tmp65_;
	GeeLinkedList* _tmp66_;
	GeeLinkedList* _tmp67_;
	gpointer _tmp68_;
	DisplayVirtualMonitor* _tmp69_;
	gdouble _tmp70_;
	gdouble _tmp71_;
	GtkComboBoxText* _tmp72_;
	GtkSwitch* _tmp73_;
	DisplayMonitorManager* _tmp74_;
	gboolean _tmp75_;
	gboolean _tmp76_;
	GtkSwitch* _tmp77_;
	parent_class = G_OBJECT_CLASS (display_displays_view_parent_class);
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAYS_VIEW, DisplayDisplaysView);
	_data3_ = g_slice_new0 (Block3Data);
	_data3_->_ref_count_ = 1;
	_data3_->self = g_object_ref (self);
	_tmp0_ = display_displays_overlay_new ();
	gtk_widget_set_vexpand ((GtkWidget*) _tmp0_, TRUE);
	g_object_ref_sink (_tmp0_);
	_g_object_unref0 (self->displays_overlay);
	self->displays_overlay = _tmp0_;
	_tmp1_ = (GtkLabel*) gtk_label_new (_ ("Mirror Display:"));
	g_object_ref_sink (_tmp1_);
	mirror_label = _tmp1_;
	_tmp2_ = (GtkSwitch*) gtk_switch_new ();
	g_object_ref_sink (_tmp2_);
	_data3_->mirror_switch = _tmp2_;
	_tmp3_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp3_, 6);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp3_, 6);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp3_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp3_, 6);
	gtk_widget_set_valign ((GtkWidget*) _tmp3_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp3_);
	_data3_->mirror_box = _tmp3_;
	_tmp4_ = _data3_->mirror_box;
	_tmp5_ = mirror_label;
	gtk_box_append (_tmp4_, (GtkWidget*) _tmp5_);
	_tmp6_ = _data3_->mirror_box;
	_tmp7_ = _data3_->mirror_switch;
	gtk_box_append (_tmp6_, (GtkWidget*) _tmp7_);
	_tmp8_ = (GtkLabel*) gtk_label_new (_ ("Scaling factor:"));
	g_object_ref_sink (_tmp8_);
	dpi_label = _tmp8_;
	_tmp9_ = (GtkComboBoxText*) gtk_combo_box_text_new ();
	g_object_ref_sink (_tmp9_);
	_g_object_unref0 (self->priv->dpi_combo);
	self->priv->dpi_combo = _tmp9_;
	_tmp10_ = self->priv->dpi_combo;
	_tmp11_ = g_strconcat (_ ("LoDPI"), " (1×)", NULL);
	_tmp12_ = _tmp11_;
	gtk_combo_box_text_append_text (_tmp10_, _tmp12_);
	_g_free0 (_tmp12_);
	_tmp13_ = self->priv->dpi_combo;
	_tmp14_ = g_strconcat (_ ("HiDPI"), " (2×)", NULL);
	_tmp15_ = _tmp14_;
	gtk_combo_box_text_append_text (_tmp13_, _tmp15_);
	_g_free0 (_tmp15_);
	_tmp16_ = self->priv->dpi_combo;
	_tmp17_ = g_strconcat (_ ("HiDPI"), " (3×)", NULL);
	_tmp18_ = _tmp17_;
	gtk_combo_box_text_append_text (_tmp16_, _tmp18_);
	_g_free0 (_tmp18_);
	_tmp19_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp19_, 6);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp19_, 6);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp19_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp19_, 6);
	g_object_ref_sink (_tmp19_);
	dpi_box = _tmp19_;
	_tmp20_ = dpi_box;
	_tmp21_ = dpi_label;
	gtk_box_append (_tmp20_, (GtkWidget*) _tmp21_);
	_tmp22_ = dpi_box;
	_tmp23_ = self->priv->dpi_combo;
	gtk_box_append (_tmp22_, (GtkWidget*) _tmp23_);
	_tmp24_ = (GtkButton*) gtk_button_new_with_label (_ ("Detect Displays"));
	g_object_ref_sink (_tmp24_);
	detect_button = _tmp24_;
	_tmp25_ = (GtkButton*) gtk_button_new_with_label (_ ("Apply"));
	g_object_ref_sink (_tmp25_);
	_data3_->apply_button = _tmp25_;
	_tmp26_ = _data3_->apply_button;
	gtk_widget_add_css_class ((GtkWidget*) _tmp26_, GRANITE_STYLE_CLASS_SUGGESTED_ACTION);
	_tmp27_ = _data3_->apply_button;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp27_, FALSE);
	_tmp28_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
	gtk_box_set_homogeneous (_tmp28_, TRUE);
	gtk_widget_set_margin_top ((GtkWidget*) _tmp28_, 6);
	gtk_widget_set_margin_end ((GtkWidget*) _tmp28_, 6);
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp28_, 6);
	gtk_widget_set_margin_start ((GtkWidget*) _tmp28_, 6);
	gtk_widget_set_valign ((GtkWidget*) _tmp28_, GTK_ALIGN_CENTER);
	g_object_ref_sink (_tmp28_);
	button_box = _tmp28_;
	_tmp29_ = button_box;
	_tmp30_ = detect_button;
	gtk_box_append (_tmp29_, (GtkWidget*) _tmp30_);
	_tmp31_ = button_box;
	_tmp32_ = _data3_->apply_button;
	gtk_box_append (_tmp31_, (GtkWidget*) _tmp32_);
	_tmp33_ = (GtkActionBar*) gtk_action_bar_new ();
	g_object_ref_sink (_tmp33_);
	action_bar = _tmp33_;
	_tmp34_ = action_bar;
	gtk_widget_add_css_class ((GtkWidget*) _tmp34_, GRANITE_STYLE_CLASS_FLAT);
	_tmp35_ = action_bar;
	_tmp36_ = dpi_box;
	gtk_action_bar_pack_start (_tmp35_, (GtkWidget*) _tmp36_);
	_tmp37_ = action_bar;
	_tmp38_ = _data3_->mirror_box;
	gtk_action_bar_pack_start (_tmp37_, (GtkWidget*) _tmp38_);
	_tmp39_ = g_settings_schema_source_get_default ();
	_tmp40_ = _g_settings_schema_source_ref0 (_tmp39_);
	schema_source = _tmp40_;
	_tmp41_ = schema_source;
	_tmp42_ = g_settings_schema_source_lookup (_tmp41_, DISPLAY_DISPLAYS_VIEW_TOUCHSCREEN_SETTINGS_PATH, TRUE);
	rotation_lock_schema = _tmp42_;
	_tmp43_ = rotation_lock_schema;
	if (_tmp43_ != NULL) {
		GtkBox* _tmp44_ = NULL;
		GtkActionBar* _tmp45_;
		GtkBox* _tmp46_;
		_tmp44_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
		gtk_widget_set_margin_top ((GtkWidget*) _tmp44_, 6);
		gtk_widget_set_margin_end ((GtkWidget*) _tmp44_, 6);
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp44_, 6);
		gtk_widget_set_margin_start ((GtkWidget*) _tmp44_, 6);
		gtk_widget_set_valign ((GtkWidget*) _tmp44_, GTK_ALIGN_CENTER);
		g_object_ref_sink (_tmp44_);
		_g_object_unref0 (self->priv->rotation_lock_box);
		self->priv->rotation_lock_box = _tmp44_;
		_tmp45_ = action_bar;
		_tmp46_ = self->priv->rotation_lock_box;
		gtk_action_bar_pack_start (_tmp45_, (GtkWidget*) _tmp46_);
		display_displays_view_detect_accelerometer (self, NULL, NULL);
	} else {
		g_info ("DisplaysView.vala:88: Schema \"org.gnome.settings-daemon.peripherals.t" \
"ouchscreen\" is not installed on your system.");
	}
	_tmp47_ = action_bar;
	_tmp48_ = button_box;
	gtk_action_bar_pack_end (_tmp47_, (GtkWidget*) _tmp48_);
	gtk_orientable_set_orientation ((GtkOrientable*) self, GTK_ORIENTATION_VERTICAL);
	_tmp49_ = (GtkSeparator*) gtk_separator_new (GTK_ORIENTATION_HORIZONTAL);
	g_object_ref_sink (_tmp49_);
	_tmp50_ = _tmp49_;
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp50_);
	_g_object_unref0 (_tmp50_);
	_tmp51_ = self->displays_overlay;
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp51_);
	_tmp52_ = action_bar;
	gtk_box_append ((GtkBox*) self, (GtkWidget*) _tmp52_);
	_tmp53_ = self->displays_overlay;
	g_signal_connect_data (_tmp53_, "configuration-changed", (GCallback) __display_displays_view___lambda17__display_displays_overlay_configuration_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp54_ = display_monitor_manager_get_default ();
	_data3_->monitor_manager = _tmp54_;
	_tmp55_ = _data3_->mirror_box;
	_tmp56_ = _data3_->monitor_manager;
	_tmp57_ = display_monitor_manager_get_monitors (_tmp56_);
	_tmp58_ = _tmp57_;
	_tmp59_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp58_);
	_tmp60_ = _tmp59_;
	gtk_widget_set_sensitive ((GtkWidget*) _tmp55_, _tmp60_ > 1);
	_tmp61_ = _data3_->monitor_manager;
	g_signal_connect_data ((GObject*) _tmp61_, "notify::monitor-number", (GCallback) __display_displays_view___lambda18__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp62_ = detect_button;
	g_signal_connect_object (_tmp62_, "clicked", (GCallback) __display_displays_view___lambda19__gtk_button_clicked, self, 0);
	_tmp63_ = _data3_->apply_button;
	g_signal_connect_data (_tmp63_, "clicked", (GCallback) __display_displays_view___lambda20__gtk_button_clicked, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp64_ = self->priv->dpi_combo;
	_tmp65_ = _data3_->monitor_manager;
	_tmp66_ = display_monitor_manager_get_virtual_monitors (_tmp65_);
	_tmp67_ = _tmp66_;
	_tmp68_ = gee_abstract_list_get ((GeeAbstractList*) _tmp67_, 0);
	_tmp69_ = (DisplayVirtualMonitor*) _tmp68_;
	_tmp70_ = display_virtual_monitor_get_scale (_tmp69_);
	_tmp71_ = _tmp70_;
	gtk_combo_box_set_active ((GtkComboBox*) _tmp64_, ((gint) _tmp71_) - 1);
	_g_object_unref0 (_tmp69_);
	_tmp72_ = self->priv->dpi_combo;
	g_signal_connect_data ((GtkComboBox*) _tmp72_, "changed", (GCallback) __display_displays_view___lambda21__gtk_combo_box_changed, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_tmp73_ = _data3_->mirror_switch;
	_tmp74_ = _data3_->monitor_manager;
	_tmp75_ = display_monitor_manager_get_is_mirrored (_tmp74_);
	_tmp76_ = _tmp75_;
	gtk_switch_set_active (_tmp73_, _tmp76_);
	_tmp77_ = _data3_->mirror_switch;
	g_signal_connect_data ((GObject*) _tmp77_, "notify::active", (GCallback) __display_displays_view___lambda22__g_object_notify, block3_data_ref (_data3_), (GClosureNotify) block3_data_unref, 0);
	_g_settings_schema_unref0 (rotation_lock_schema);
	_g_settings_schema_source_unref0 (schema_source);
	_g_object_unref0 (action_bar);
	_g_object_unref0 (button_box);
	_g_object_unref0 (detect_button);
	_g_object_unref0 (dpi_box);
	_g_object_unref0 (dpi_label);
	_g_object_unref0 (mirror_label);
	block3_data_unref (_data3_);
	_data3_ = NULL;
	return obj;
}

static void
display_displays_view_class_init (DisplayDisplaysViewClass * klass,
                                  gpointer klass_data)
{
	display_displays_view_parent_class = g_type_class_peek_parent (klass);
	g_type_class_adjust_private_offset (klass, &DisplayDisplaysView_private_offset);
	G_OBJECT_CLASS (klass)->constructor = display_displays_view_constructor;
	G_OBJECT_CLASS (klass)->finalize = display_displays_view_finalize;
}

static void
display_displays_view_instance_init (DisplayDisplaysView * self,
                                     gpointer klass)
{
	self->priv = display_displays_view_get_instance_private (self);
}

static void
display_displays_view_finalize (GObject * obj)
{
	DisplayDisplaysView * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, DISPLAY_TYPE_DISPLAYS_VIEW, DisplayDisplaysView);
	_g_object_unref0 (self->displays_overlay);
	_g_object_unref0 (self->priv->dpi_combo);
	_g_object_unref0 (self->priv->rotation_lock_box);
	G_OBJECT_CLASS (display_displays_view_parent_class)->finalize (obj);
}

static GType
display_displays_view_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (DisplayDisplaysViewClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) display_displays_view_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DisplayDisplaysView), 0, (GInstanceInitFunc) display_displays_view_instance_init, NULL };
	GType display_displays_view_type_id;
	display_displays_view_type_id = g_type_register_static (gtk_box_get_type (), "DisplayDisplaysView", &g_define_type_info, 0);
	DisplayDisplaysView_private_offset = g_type_add_instance_private (display_displays_view_type_id, sizeof (DisplayDisplaysViewPrivate));
	return display_displays_view_type_id;
}

GType
display_displays_view_get_type (void)
{
	static volatile gsize display_displays_view_type_id__once = 0;
	if (g_once_init_enter (&display_displays_view_type_id__once)) {
		GType display_displays_view_type_id;
		display_displays_view_type_id = display_displays_view_get_type_once ();
		g_once_init_leave (&display_displays_view_type_id__once, display_displays_view_type_id);
	}
	return display_displays_view_type_id__once;
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

